<template>
  <div>
    <AddUser v-show="isAddUserVisible" @close="closeAddUser" @update-users="getUsers" />
    <div class="p-6 pb-0">
      <UiButton class="px-4 rounded-16 w-max" @click="openAddUser">Add Super User</UiButton>
    </div>
    <div class="flex flex-col gap-6 p-6">
      <div v-for="(user, index) in users" :key="user.public_address" class="w-full rounded-16 bg-bgdtert">
        <UserCard :user="user" :index="index" @update-users="getUsers" />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { getSuperUsers } from '@/api/admin';
import { disableBodyScroll, enableBodyScroll } from 'body-scroll-lock';

import UiButton from '@/components/ui/UiButton.vue';
import UserCard from '@/components/views/admin/users/UserCard.vue';
import AddUser from '@/components/views/admin/users/AddUser.vue';

export default {
  name: 'UserList',

  components: { UiButton, UserCard, AddUser },

  data() {
    return {
      users: [],

      isAddUserVisible: false,
    };
  },

  mounted() {
    this.getUsers();
  },

  methods: {
    openAddUser() {
      this.isAddUserVisible = true;
      const el = document.querySelector('#addUser');
      disableBodyScroll(el);
    },

    closeAddUser() {
      this.isAddUserVisible = false;
      const el = document.querySelector('#addUser');
      enableBodyScroll(el);
    },

    async getUsers() {
      this.$store.commit('setAdminLoading', true);

      try {
        const res = await getSuperUsers();
        this.users = res.data.results;
      } catch (err) {
        console.error(err);
      } finally {
        this.$store.commit('setAdminLoading', false);
      }
    },
  },
};
</script>
